/*
 * Copyright (c) 2016, 2017, 2018, 2019 FabricMC
 * Copyright 2023 The Quilt Project
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package net.fabricmc.fabric.mixin.attachment;

import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;
import net.fabricmc.fabric.impl.attachment.AttachmentPersistentState;
import net.minecraft.class_18;
import net.minecraft.class_18.class_8645;
import net.minecraft.class_3218;

@Mixin(class_3218.class)
abstract class ServerWorldMixin {
	@Inject(at = @At("TAIL"), method = "<init>")
	private void createAttachmentsPersistentState(CallbackInfo ci) {
		// Force persistent state creation
		class_3218 world = (class_3218) (Object) this;
		var type = new class_18.class_8645<>(
				() -> new AttachmentPersistentState(world),
				nbt -> AttachmentPersistentState.read(world, nbt),
				null // Object builder API 12.1.0 and later makes this a no-op
		);
		world.method_17983().method_17924(type, AttachmentPersistentState.ID);
	}
}
